<?php
/**
 * FooWidget Class
 */
class GVWidget extends WP_Widget {
    /** constructor */
    function GVWidget() {
        parent::WP_Widget(false, $name = 'Google Voice CallMe');  
    }

    /** @see WP_Widget::widget */
    function widget($args, $instance) {     
        extract( $args );
        ?>
              <?php echo $before_widget; ?>
                  <?php echo $before_title;
                        if ($instance['title'])
                             echo $instance['title'];
                        echo $after_title; 
                   ?>
                 <?php echo $this->display($instance); ?>
              <?php echo $after_widget; ?>
        <?php
    }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {             
        return $new_instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {              
        $title = esc_attr($instance['title']);
        ?>
            <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
            <p>
            <hr width="90%"/>
            <p><strong><u>Do Not Disturb</u></strong></p>
            <p><strong>Current Time:</strong>&nbsp;<?php echo date('h:i a T');?></p> 
            <p><strong>Days of the Week:</strong></p>
            <div>
                <label for="<?php echo $this->get_field_id('Sunday'); ?>"><input id="<?php echo $this->get_field_id('Sunday'); ?>" name="<?php echo $this->get_field_name('Sunday'); ?>" type="checkbox" value="1" <?php echo $instance['Sunday'] ? 'checked' : ''; ?>/><?php _e('Sunday'); ?></label><br/>
                <div align="right">Start: <?php $this->time_select('Sunday-Start'); ?><br/></div>
                <div align="right">End: <?php $this->time_select('Sunday-End'); ?><br/></div>
            </div>
            <div>
                <label for="<?php echo $this->get_field_id('Monday'); ?>"><input id="<?php echo $this->get_field_id('Monday'); ?>" name="<?php echo $this->get_field_name('Monday'); ?>" type="checkbox" value="1" <?php echo $instance['Monday'] ? 'checked' : ''; ?>/><?php _e('Monday'); ?></label><br/>
                <div align="right">Start: <?php $this->time_select('Monday-Start'); ?><br/></div>
                <div align="right">End: <?php $this->time_select('Monday-End'); ?><br/></div>
            </div>
            <div>
                <label for="<?php echo $this->get_field_id('Tuesday'); ?>"><input id="<?php echo $this->get_field_id('Tuesday'); ?>" name="<?php echo $this->get_field_name('Tuesday'); ?>" type="checkbox" value="1" <?php echo $instance['Tuesday'] ? 'checked' : ''; ?>/><?php _e('Tuesday'); ?></label><br/>
                <div align="right">Start: <?php $this->time_select('Tuesday-Start'); ?><br/></div>
                <div align="right">End: <?php $this->time_select('Tuesday-End'); ?><br/></div>
            </div>
            <div>
                <label for="<?php echo $this->get_field_id('Wednesday'); ?>"><input id="<?php echo $this->get_field_id('Wednesday'); ?>" name="<?php echo $this->get_field_name('Wednesday'); ?>" type="checkbox" value="1" <?php echo $instance['Wednesday'] ? 'checked' : ''; ?>/><?php _e('Wednesday'); ?></label><br/>
                <div align="right">Start: <?php $this->time_select('Wednesday-Start'); ?><br/></div>
                <div align="right">End: <?php $this->time_select('Wednesday-End'); ?><br/></div>
            </div>
            <div>
                <label for="<?php echo $this->get_field_id('Thursday'); ?>"><input id="<?php echo $this->get_field_id('Thursday'); ?>" name="<?php echo $this->get_field_name('Thursday'); ?>" type="checkbox" value="1" <?php echo $instance['Thursday'] ? 'checked' : ''; ?>/><?php _e('Thursday'); ?></label><br/>
                <div align="right">Start: <?php $this->time_select('Thursday-Start'); ?><br/></div>
                <div align="right">End: <?php $this->time_select('Thursday-End'); ?><br/></div>
            </div>
            <div>
                <label for="<?php echo $this->get_field_id('Friday'); ?>"><input id="<?php echo $this->get_field_id('Friday'); ?>" name="<?php echo $this->get_field_name('Friday'); ?>" type="checkbox" value="1" <?php echo $instance['Friday'] ? 'checked' : ''; ?>/><?php _e('Friday'); ?></label><br/>
                <div align="right">Start: <?php $this->time_select('Friday-Start'); ?><br/></div>
                <div align="right">End: <?php $this->time_select('Friday-End'); ?><br/></div>
            </div>
            <div>
                <label for="<?php echo $this->get_field_id('Saturday'); ?>"><input id="<?php echo $this->get_field_id('Saturday'); ?>" name="<?php echo $this->get_field_name('Saturday'); ?>" type="checkbox" value="1" <?php echo $instance['Saturday'] ? 'checked' : ''; ?>/><?php _e('Saturday'); ?></label><br/>
                <div align="right">Start: <?php $this->time_select('Saturday-Start'); ?><br/></div>
                <div align="right">End: <?php $this->time_select('Saturday-End'); ?><br/></div>
            </div>
        <?php 
    }

    function time_select($name, $class='')
    {
      ?> 
      <select name="<?php echo $this->get_field_name($name.'-Hour'); ?>" id="<?php echo $this->get_field_id($name.'-Hour'); ?>" class="<?php echo $class; ?>">
      <?php
      for ($i=1; $i <= 12; $i++)
      {
          echo "<option value='$i' ";
          echo $instance[$name.'-Hour'] ? 'selected' : '';
          echo ">$i</option>";
      }
      ?>
      </select>
      <select name="<?php echo $this->get_field_name($name.'-Min'); ?>" id="<?php echo $this->get_field_id($name.'-Min'); ?>" class="<?php echo $class; ?>">
      <?php
      for ($i=0; $i <= 59; $i++)
      {
          if ($i < 10)
              $min = '0'.$i;
          else
              $min = $i;

          if (date('i') == $min)
              echo "<option value='$min' selected>$min</option>";
          else
              echo "<option value='$min'>$min</option>";
      }
      ?>
      </select>
      <select name="<?php echo $this->get_field_name($name.'-Meridiem'); ?>" id="<?php echo $this->get_field_id($name.'-Meridiem'); ?>" class="<?php echo $class; ?>">
          <?php
          $cycle = array('am','pm');
          foreach ($cycle as $meridiem)
          {
              if (date('a') == $meridiem)
                  echo "<option value='$meridiem' selected>$meridiem</option>";
              else
                  echo "<option value='$meridiem'>$meridiem</option>";
          }
          ?> 
      </select>
      <?php 
    }

    function display($instance)
    {
        $now = time();
        $day = date('l');
		
        $dnd_start = $instance[$day.'-Start-Hour'].':';
        $dnd_start .= $instance[$day.'-Start-Min'].' ';
        $dnd_start .= $instance[$day.'-Start-Meridiem'];		
        $dnd_end = $instance[$day.'-End-Hour'].':';
        $dnd_end .= $instance[$day.'-End-Min'].' ';
        $dnd_end .= $instance[$day.'-End-Meridiem'];        
        $dnd_start = strtotime($dnd_start);
        $dnd_end = strtotime($dnd_end);

        if ($dnd_start < $now && $now < $dnd_end)
            return get_option('google_voice_callme_dnd_html');
		else
            return get_option('google_voice_callme_html');
	}
} // class GVWidget

// register GVWidget widget
add_action('widgets_init', create_function('', 'return register_widget("GVWidget");'));

?>
